import java.io.*;
import java.net.*;
public class ClientSession extends Thread {
	private Socket socket;
	private BufferedReader in;
	private PrintWriter out;
	private ActiveSessions as;
	private Broadcaster broadcaster;
	public ClientSession(Socket s, ActiveSessions as, Broadcaster b){
		socket = s;
		this.as = as;
		broadcaster = b;
		try {
	        System.out.println("Connection accepted: "+ socket);
	        
	        in = 
	          new BufferedReader(
	            new InputStreamReader(
	              socket.getInputStream()));
	        
	        out = 
	          new PrintWriter(
	            new BufferedWriter(
	              new OutputStreamWriter(
	                socket.getOutputStream())),true);  // flush
	        
	        start();
		
		} catch(IOException e){
			
		}
	}
	public void run() {
		try {
		        out.println("Tere! Mis Su nimi on?");
		        String nimi = in.readLine();
		        //nimi = clean(nimi);
		        this.setName(nimi);
		        as.add(this);
		        
		        String answer = nimi+" tuli sisse!";
		        broadcaster.sendToEveryone(answer);
		        sendMessage("\n"+answer);  // debugging
		        
		        while(true){
	    	        String command = in.readLine();
	    	        if(command==null)
	    	        	continue;
	    	        //command = clean(command);
	    	        if(command.length()==0)
	    	        	continue;
	    	        
	    	        answer = nimi+" lausub: "+command;
	    	        broadcaster.sendToEveryone(answer);
	    	        sendMessage("\n"+answer);  // debugging
		        }
		} catch(IOException e){ 
	        
	    } finally {
		        System.out.println("closing Socket "+socket);
		        try {
		        	socket.close();
		        } catch(IOException e){}
	     }		
	}
	public void sendMessage(String message){
		out.println(message);
	}
	public static String clean(String str){
		int i;
		for( i=0;i<str.length();i++){
			char c = str.charAt(i);
			//System.out.println((int)c+"\t"+c);
			if(c>=48 && c<255)
				break;
		}
		return str.substring(i);
	}
}
